C     BIF.F
C     PROGRAM TO GENERATE BIFURCATION DIAGRAMS

C     ORIGINALLY WRITTEN 3/4/1994 WHILE A STUDENT AT UNIV OF WISCONSIN-
C     RIVER FALLS.

C     COPYRIGHT (C) 1994, 2007 JIM HALL, JHALL@FREEDOS.ORG
C Permission is hereby granted, free of charge, to any person obtaining
C a copy of this software and associated documentation files (the
C "Software"), to deal in the Software without restriction, including
C without limitation the rights to use, copy, modify, merge, publish,
C distribute, sublicense, and/or sell copies of the Software, and to
C permit persons to whom the Software is furnished to do so, subject to
C the following conditions:
C
C The above copyright notice and this permission notice shall be
C included in all copies or substantial portions of the Software.
C
C THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
C EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
C MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
C NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
C LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
C OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
C WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

      PROGRAM BIF
      PARAMETER (ITERMAX = 300)
      PARAMETER (ITERPLOT = 200)
      PARAMETER (XINIT = 4.25, XEND = 9.75)
      PARAMETER (XSEED = .8535533)
      PARAMETER (CSIZE = 800.)

C     PRINT THE LIMITS (USE GNUPLOT COMMENT STYLE)

      PRINT *, '## ', XINIT, ' - ', XEND
      PRINT *, '## SEED OF X = ', XSEED

C     ITERATE THE FUNCTION

      CSTEP = (XEND - XINIT) / CSIZE

      DO C = XINIT, XEND, CSTEP
         X = XSEED

         DO  I = 1, ITERMAX, 1
            X = FUNC(X, C)

            IF (I.GT.ITERPLOT) THEN
               PRINT *, C, X
            ENDIF
         ENDDO
      ENDDO
      END

      FUNCTION FUNC(X, C)
      FUNC = C * X * (1.0 - X) * (1.0 - (2.0 * X))**2
      END
